Bug 390451 - Pick up paging performance improvements from upstream Xen
Pick up paging performance improvements from upstream Xen
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel-xen (Show other bugs)
5.1
All Linux
low Severity low
: ---
: ---
Assigned To: Paolo Bonzini
Virtualization Bugs
:
Depends On:
Blocks: 514490 KernelXenUpstream
  Show dependency treegraph
 
Reported: 2007-11-19 10:04 EST by Stephen Tweedie
Modified: 2011-07-21 06:27 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-07-21 06:27:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
pte_clear patch (748 bytes, patch)
2010-12-07 13:11 EST, Paolo Bonzini
no flags Details | Diff

  None (edit)
Description Stephen Tweedie 2007-11-19 10:04:33 EST
Upstream Xen-3.1 contains the following in changeset 14731:

>         # HG changeset patch
>         # User kfraser@localhost.localdomain
>         # Date 1175760633 -3600
>         # Node ID 14c25e48a55730115c71e592ae065e715c1d23af
>         # Parent  07d3208c0ca3b6e746745d2bc08f7aa12ed39269
>         linux: improve x86 page table handling performance
>         
>         Where possible,
>         - use hypercalls instead of writing to read-only pages
>         - fold TLB flushes into page table update hypercalls
>         - on PAE, use single-access updates instead of two-access ones
>         
>         The single change to PAE pte_clear() yields a 25-30% boost for kernel
>         builds on a 4x2x2 CPUs, 8Gb box; the other changes together yield
>         improvements of 2-5%.

Note that it also needs the bugfixes from upstream linux-2.6.18-xen.hg's csets
265 and 266.

Given the magnitude of the performance improvement quoted, we should at least
evaluate this for 5.2.
Comment 1 Bill Burns 2008-02-28 16:00:10 EST
Missed the boat for RHEL 5.2, flaged to look at for 5.3.
Comment 2 RHEL Product and Program Management 2008-06-09 17:59:43 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 4 Paolo Bonzini 2010-12-07 13:11:11 EST
Created attachment 465972 [details]
pte_clear patch

I think backporting the whole series is pretty much out of question at this point.

However, if the pte_clear hunk is really that effective, it may be worthwhile to benchmark it.
Comment 5 Paolo Bonzini 2011-01-31 12:58:58 EST
Measured 2-3% improvement on a 2 VCPU RHEL5 32-bit guest running on 64-bit host
Comment 6 RHEL Product and Program Management 2011-02-04 15:30:40 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 13 Jarod Wilson 2011-03-16 14:00:38 EDT
Patch(es) available in kernel-2.6.18-248.el5
Detailed testing feedback is always welcomed.
Comment 16 errata-xmlrpc 2011-07-21 06:27:51 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2011-1065.html

Note You need to log in before you can comment on or make changes to this bug.